Bug 843292 - Exception AttributeError: '_read_only' [...] ignored
Summary: Exception AttributeError: '_read_only' [...] ignored
Keywords:
Status: CLOSED WORKSFORME
Alias: None
Product: Fedora
Classification: Fedora
Component: fedpkg
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Dennis Gilmore
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 845482 887790 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-07-26 01:10 UTC by Josh Stone
Modified: 2016-06-30 07:52 UTC (History)
17 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-06-30 07:47:29 UTC


Attachments (Terms of Use)

Description Josh Stone 2012-07-26 01:10:02 UTC
Description of problem:
Many fedpkg commands are printing (but ignoring) an AttributeError exception.  I haven't found any ill effects from this though.

Version-Release number of selected component (if applicable):
fedpkg-1.9-1.fc17.noarch

How reproducible:
100%

Steps to Reproduce:
1. fedpkg clone dyninst
2. cd dyninst/
3. fedpkg verrel
  
Actual results:
$ fedpkg verrel
Exception AttributeError: '_read_only' in <bound method write.__del__ of <git.config.write object at 0x120f980>> ignored
dyninst-7.99-0.21.fc18

Expected results:
No Exceptions.

Additional info:
I've only seen this with the "dyninst" repo.  Others I've looked at, like "kernel" and "systemtap", are all fine.  I wonder if there's some corner case since "dyninst" is pretty new and only has a master branch so far.

Comment 1 Brian Lane 2012-08-13 18:30:43 UTC
Same problem with newly created python-egenix-mx-base

Comment 2 Josh Stone 2012-08-13 18:39:05 UTC
Interesting - and now that F-18 has branched, so dyninst has added an origin/f18 git branch, the error no longer occurs.  So this does seem to be limited to rawhide-only packages...

Comment 3 Josh Stone 2012-08-13 18:45:56 UTC
One more confirmation: I deleted f18 locally (git branch -d -r origin/f18) and the error returned; git-fetch it again and the error goes away.  All this while while my working tree is on the local master synced to origin/master, and I have no other local branches.

Comment 4 Fedora Admin XMLRPC Client 2012-11-30 18:27:31 UTC
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.

Comment 5 David Juran 2013-01-22 12:38:06 UTC
*** Bug 845482 has been marked as a duplicate of this bug. ***

Comment 6 David Juran 2013-01-22 12:38:49 UTC
*** Bug 887790 has been marked as a duplicate of this bug. ***

Comment 7 David Juran 2013-01-22 12:39:28 UTC
Seems this problem is also visible on F18 and rawhide

Comment 8 Mikolaj Izdebski 2013-01-23 16:24:41 UTC
I am able to reproduce this bug in rawhide-only package (maven-shared-incremental).

$ fedpkg import maven-shared-incremental-1.0-1.fc18.src.rpm
Uploading: ef53728cb851dfd7e2bc6050c05a1e01  maven-shared-incremental-1.0-source-release.zip
Exception AttributeError: '_read_only' in <bound method write.__del__ of <git.config.write object at 0x24de8a0>> ignored

And the process hangs.

Version-Release number of selected component (if applicable):
1.11-1.fc18.noarch

Comment 9 Mikolaj Izdebski 2013-01-23 17:05:21 UTC
I confirm that adding another git branch helped to workaround this bug.

Comment 10 Alan Pevec 2013-02-21 16:06:08 UTC
Also workaround is to specify --dist explicitly e.g. fedpkg --dist f19 verrel

Comment 11 Fedora End Of Life 2013-07-03 22:08:24 UTC
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 12 Jiri Popelka 2013-09-16 13:29:45 UTC
Same with fedpkg-1.14-1.fc20 and freshly created repo, adding some other branch has helped.

Comment 13 Mat Booth 2014-04-17 14:41:31 UTC
I see this also on F20 with fedpkg fedpkg-1.15-1.fc20.noarch

Comment 14 Milan Bouchet-Valat 2014-05-01 20:44:52 UTC
Seen here too on F20.

Comment 15 Richard W.M. Jones 2014-05-02 08:24:42 UTC
Also seen on F20.

Exception AttributeError: '_read_only' in <bound method write.__del__ of <git.config.write object at 0x199f9f0>> ignored

Can someone explain what this means?

Comment 16 Pavol Babinčák 2014-05-02 08:31:39 UTC
(In reply to Richard W.M. Jones from comment #15)
> Also seen on F20.
> 
> Exception AttributeError: '_read_only' in <bound method write.__del__ of
> <git.config.write object at 0x199f9f0>> ignored
> 
> Can someone explain what this means?
When I looked into this in the past it looked like there are two attributes of the same name and somehow one of them is readonly at the time of object destruction. Exception is thrown in destructor (__del__()) and that shouldn't be done in the correct code. I haven't managed to find the original cause for this at that time but I believe this error quite harmless.

Comment 17 Mat Booth 2014-05-02 08:35:48 UTC
(In reply to Pavol Babinčák from comment #16)
> (In reply to Richard W.M. Jones from comment #15)
> > Also seen on F20.
> > 
> > Exception AttributeError: '_read_only' in <bound method write.__del__ of
> > <git.config.write object at 0x199f9f0>> ignored
> > 
> > Can someone explain what this means?
> When I looked into this in the past it looked like there are two attributes
> of the same name and somehow one of them is readonly at the time of object
> destruction. Exception is thrown in destructor (__del__()) and that
> shouldn't be done in the correct code. I haven't managed to find the
> original cause for this at that time but I believe this error quite harmless.

The error is harmless but it does seem to come with a productivity killing hang -- as if there is some several second timeout. If I create another branch (the workaround documented above), then things happen a lot quicker.

Comment 18 cqi 2016-06-30 04:06:54 UTC
Cannot reproduce this bug with fedpkg-1.23-1.fc23.noarch

fedpkg clone kdepim4
cd kdepim4
fedpkg verrel
kdepim4-4.14.10-26.fc25

Close this bug. Feel free to file issue in pagure.io[1] if similar problem happens again.

[1] https://pagure.io/fedpkg/new_issue

Comment 19 Vít Ondruch 2016-06-30 05:03:13 UTC
(In reply to cqi from comment #18)
> Cannot reproduce this bug with fedpkg-1.23-1.fc23.noarch
> 
> fedpkg clone kdepim4

kdepim4 is definitely not the right component, since it has more branches then just master. IOW see the comment #8 and comment #9

I have not tested if this is fixed or not, I'm just saying that you definitely used wrong reproducer.

Comment 20 cqi 2016-06-30 07:26:31 UTC
(In reply to Vít Ondruch from comment #19)
> (In reply to cqi from comment #18)
> > Cannot reproduce this bug with fedpkg-1.23-1.fc23.noarch
> > 
> > fedpkg clone kdepim4
> 
> kdepim4 is definitely not the right component, since it has more branches
> then just master. IOW see the comment #8 and comment #9
> 
> I have not tested if this is fixed or not, I'm just saying that you
> definitely used wrong reproducer.

Thanks for pointing out this. I just tried to reproduce it again with following steps,

1. rhpkg-stage clone python-pytest-pep8

At this moment, I cannot find a repo from Fedora dist-git that has master branch only. So, I used python-pytest-pep8 created in dist-git-qa that only has one master branch.

2. rhpkg-stage import python-pytest-pep8-1.0.6-1.fc21.src.rpm

This aims to test whether bug can be reproduced mentioned in comment 8.

Most subcommands of rhpkg and fedpkg inherit from pyrpkg directly without changes. In this case, import is the one that is provided by pyrpkg and shared by rhpkg and fedpkg. So, in step 2, it makes sense to use rhpkg-stage.

Result is the srpm is imported without error.

3. fedpkg verrel

As mentioned above, verrel subcommand is shared by rhpkg and fedpkg. This step aims to reproduce the original bug report.

Result is python-pytest-pep8-1.0.6-1.fc25 is printed, and no error happens.

Comment 21 Emmanuel Seyman 2016-06-30 07:47:29 UTC
(In reply to Vít Ondruch from comment #19)
>
> kdepim4 is definitely not the right component, since it has more branches
> then just master. IOW see the comment #8 and comment #9

JFTR, running the command "fedpkg clone php-pecl-apcu-bc" (php-pecl-apcu-bc currently only has the master branch) completes rapidly and without errors.

Comment 22 Vít Ondruch 2016-06-30 07:52:08 UTC
(In reply to cqi from comment #20)
> At this moment, I cannot find a repo from Fedora dist-git that has master
> branch only.

Looking at recent package reviews [1], it seems that for example perl-Module-Install-Copyright [2] has just the master branch so far. Trying the "verrel" above that package, I can't reproduce the issue. So you were probably right this was resolved somehow in the mean time. I'm closing this issue again. Sorry for the noise.


[1] https://lists.fedoraproject.org/archives/list/package-review@lists.fedoraproject.org/
[2] https://admin.fedoraproject.org/pkgdb/package/rpms/perl-Module-Install-Copyright/


Note You need to log in before you can comment on or make changes to this bug.